// The example shows a websocket server that is returning all
// messages back to the connected client.
// After the HttpEndpoint is started, all incoming
// messages to EchoServer are handled by the class
// EchoServer.

#include "web.ch"
#INCLUDE "dcdialog.CH"


#define PORT 8100
#define SERVERNAME  GetEnv("Computername" )

PROCEDURE Main()

LOCAL oHttpEndpoint

oHttpEndpoint := HttpEndpoint():new( PORT )
oHttpEndpoint:start()

DCMSGBOX "HttpEndpoint is running on " + SERVERNAME + ':' + Alltrim(Str(PORT)) ;
   FONT '12.Lucida Console Bold'

oHttpEndpoint:stop()

RETURN

* ---------

PROC appsys ; RETURN

// A websocket handler must implement the methods
// :onConnect(), onDisconnect(), onText() and
// :onBinary().
//
// The methods are triggered from the HttpEndpoint.
//
CLASS EchoServer FROM WebSocketHandler
  EXPORTED:
    METHOD onConnect
    METHOD onDisconnect
    METHOD onText
    METHOD onBinary
ENDCLASS

METHOD EchoServer:onConnect()
WTF 'Connected'
RETURN self

METHOD EchoServer:onDisconnect()
WTF 'DisConnected'
RETURN self

METHOD EchoServer:onText( cText )
WTF cText
::sendText( cText )
RETURN self

METHOD EchoServer:onBinary( cBinary )
LOCAL i, xData := Bin2Var(cBinary)
IF Valtype(xData) == 'A'
  FOR i := 1 TO Len(xData)
    IF Valtype(xData[i]) == 'B'
      ::sendBinary( Var2Bin(Eval(xData[i])) )
    ENDIF
  NEXT
ENDIF
wtf cBinary
::sendBinary( cBinary )
RETURN self

